close all, clear all, clc
N = 4;           %liczba probek
x = rand(1,2*N); %sygnal testowy o dlugosci 2N
WN=exp(-j*2*pi*(0:(2*N)/2-1)/(2*N));
x1=x(1:2:end);   % N probek o indeksach parzystych   
x2=x(2:2:end);   % N probek o indeksach nieparzystych   
x12=x1+j*x2;     % 'sztuczny' sygnal zespolony   
X12=fft(x12);    % FFT N-punktowe
X0 =X12(1); X12(1)=[];
X1 = [real(X0) (X12+fliplr(conj(X12)))/2    ]; %DFT probek o indeksach parzystych   
X2 = [imag(X0) (X12-fliplr(conj(X12)))/(2*j)]; %DFT probek o indeksach nieparzystych   
X  = [X1+WN.*X2]; %podzial w czestotliwosci
X  = [X X1(1)-X2(1) conj(X(end:-1:2))];
%% porownanie z Matlabem
Xf=fft(x); [X(:)-Xf(:)]
