close all, clear all, clc
x = rand(1,100); %sygnal testowy
M = 30;          %dlugosc DFT
k = 3;           %prazek DFT, ktory ma byc wyznaczany
W = exp(-j*2*pi/M); % twiddle factor
%% Wartosci poczatkowe
xmr = 1;            
X0M = 0;    
xn_M= 0;
fifo= zeros(1,M);    
for n=1:length(x);        
%% bufor FIFO
    fifo= [fifo(2:M) x(n)];      
%% mSDFT 
    X1M = X0M+xmr*( x(n)-xn_M );
    X0M = X1M;
    if mod(n,M)       
        xmr=xmr*W^(k);     %ciag modulujacy
        X1M = X1M*conj(xmr);%korekcja fazy        
    else
        xmr=1;        
    end                                  
%% nowe xn_M    
    xn_M  = fifo(1);      
end
%% blad amplitudy i fazy w odniesieniu do blokowego DFT
Xk   = fft(fifo); Xk=Xk(k+1);   %blokowe DFT
Aerr = [abs(X1M)-abs(Xk)]       %blad amplitudy 
Perr = [angle(X1M)-angle(Xk)]   %blad fazy
