% Przyklad 5.4
  close all, clear all, clc
  
  M = 512;         % dlugosc filtra
  N = 10*M;        % dlugosc sygnalu
  x=randn(1,N);    % sygnal 1
  h=0.99.^(0:M-1); % sygnal 2, filtr

% Splot liniowy - funkcja Matlaba
  y1 = conv(x,h);

% Szybki splot kolowy calego sygnalu za pomoca FFT
  hz = [ h zeros(1,N-M)];               % uzupelniamy zerami drugi sygnal
                                        % do dlugosci pierwszego, dluzszego
  y2 = ifft( fft(x) .* fft( hz ) );     % szybki splot kolowy
  blad2 = max(abs(y1(M:N) - y2(M:N)))   % blad, koncowe N-M+1 probki sa poprawne

% Szybki splot liniowy calego sygnalu za pomoca FFT
  xz = [ x zeros(1,M-1)];               % uzupelniamy dluzszy sygnal M-1 zerami
  hzz = [ h zeros(1,N-M) zeros(1,M-1)]; % uzupelniamy krotszy sygnal N-1 zerami
  y3 = ifft( fft(xz) .* fft( hzz ) );   % szybki splot liniowy
  blad3 = max(abs( y1- y3))             % blad, wszystkie probki sa poprawne