function T = dctIImtx(M)                % Macierz DCT typu II o zdanym rozmiarze $M$.

[k, n] = ndgrid(0 : (M - 1), 0 : (M - 1));                  % Generacja indeksow ...
T = sqrt(2 / M) * cos((pi / M) .* k .* (n + 0.5));          % i elementow macierzy.
T(1, :) = T(1, :) ./ sqrt(2);                           % Skalowanie pierwszego wiersza.