function fb_show_prototype(p, L, fc)          % Prezentacja charaterystyk filtru ...
       % prototypowego o zadanych wspolczynnikch $p$ i czestotliwosci odciecia $fc$.

format long;   disp(p(:)');   format short;           % Wypisanie wspolczynnikow ...
                                                        % ze zwiekszona precyzja.
P = fft(p, L);          % Obliczenie $L$ punktow charakterystyki czestotliwosciowej.

figure;   plot((1 : L) / L, 20 * log10(abs(P))); %   Prezentacja charakterystyki ...
                                                   % amplitudowej z zaznaczeniem ...
line([fc fc], ylim, 'LineStyle', '--');        % nominalnej czestotliwosci odciecia.
box on;   grid on;   ylabel('|P(e^{j\Omega})|');   xlabel('\Omega/2\pi');

figure; plot(p);                                % Prezentacja odpowiedzi impulsowej.
box on;   grid on;   ylabel('p[n]');   xlabel('n');