function fb_show_response(h, L) 	    % Rysowanie charakterystyki amplitudowej ...
                                        % zespolu filtrow.

H = fft(h, L, 2);        % Wyznaczenie L punktow charakterystyki czestotliwosciowej.
figure;                                    % Pokazanie charakterystyki amplitudowej.
plot((0 : L) / L, 20 * log10(abs(H(:, [1 : end, 1])') + 1e-10));
grid on;    box on;    xlabel('\Omega/2\pi');    ylabel('|H_k(e^{j\Omega})| [dB]');