function y = filtrK_Z(x,gamma)
% Filtr kratowy - tylko zera
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl

N=length(x);
M=length(gamma);
eb(1:M) = zeros(1,M);
for n = 1 : N
   ea(1) = x(n);     % kolejna probka
   for k = 1 : M     % kolejne sekcje filtra (8.2)
      ea(k+1) = ea(k) - gamma(k)*eb(k);
      ebnext(k+1) = eb(k) - gamma(k)*ea(k);
   end
   eb = [ x(n) ebnext(2:M) ];
   y(n) = ea(k+1);
end
