function [y_bufor, e_bufor, h_bufor, h ] = filtrWRLS_faest(M,d,x,nr,lambda,delta)
% WRLS FAEST
% Implementacja w Malabie: Tomasz Zielinski (tzielin@agh.edu.pl) na podstawie [11]

h_bufor = [];          % historia przestrajania wybranych wag filtra 

xhat=0;
e=0;
h=zeros(1,M+1);
w = zeros(1,M+1);
a = zeros(1,M+1);
b = zeros(1,M+1);
ktilde = zeros(1,M);
k = zeros(1,M+1);
kbar = zeros(1,M);
w=zeros(1,M+1);
D1a = delta;
D1b = delta;
nutilde = 0;
h(1)=0; %% h(0)
a(1)=1; %% a(0)
b(M+1)=1; %% b(M)
e_bufor=[];
y_bufor=[];

for n=1:length(d)
    w(1)=x(n);
    e0a=0;
    e0a=sum(a.*w);
    e1a=e0a/(1+nutilde);
    D0a=lambda*D1a;
    k(1)=e0a/D0a;
    D1a=D0a+e1a*e0a;
    for i=1:1:M
        k(i+1)=ktilde(i)+k(1)*a(i+1);
    end
    D0b=lambda*D1b;
    e0b=k(M+1)*D0b;
    for i=1:1:M
        kbar(i)=k(i)-k(M+1)*b(i);
    end
    nu=nutilde+e0a*k(1);
    nubar=nu-e0b*k(M+1);
    e1b=e0b/(1+nubar);
    D1b=D0b+e1b*e0b;
    for i=1:1:M
        a(i+1) = a(i+1)-e1a*ktilde(i);
    end
    for i=1:1:M
        b(i)=b(i)-e1b*kbar(i);
    end
    xhat0=sum(h.*w);
    e0= d(n)-xhat0;
    e=e0/(1+nu);
    for i=1:1:M+1
        h(i)=h(i)+e*k(i);
    end
    ktilde=kbar;
    nutilde=nubar;
    w(M+1:-1:2)=w(M:-1:1);
    y_bufor=[y_bufor xhat0];
    e_bufor=[e_bufor e0];
    h_bufor=[h_bufor; h( nr ) ]; % zapisz wartosci wybranych wag filtra

end