% Przyklad 8.1
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl

  clear all; clf;

% Podaj wspolczynniki transmitancji H(z)=A(z) filtra (UWAGA! a(1)=1, M<=N)
  a = [ 1 -0.9 0.64 -0.576 ];
  N = length(a);
  aa = a(2:N); M=N-1; % odrzucamy pierwszy element rowny 1
  
% Oblicz wspolczynniki "odbicia" gamma(i) filtra kratowego - tabela 8.1,
% rownania (8.21)(8.22)
  aij(M,1:M)=aa(1:M);
  for i=M:-1:1
      gamma(i)=-aij(i,i);
      for j=1:i-1
          aij(i-1,j) = (aij(i,j)+gamma(i)*aij(i,i-j))/(1-gamma(i)^2);
      end
  end
  gamma, pause
  
% Odtworz wspolczynniki {a} na podstawie wsp. {gamma} - tabela 8.1, (8.16),(8.17)
  aa = zeros(M,M);
  aa(1,1) = -gamma(1);
  for i=2:M
     aa(i,i) = -gamma(i);
     for j=1:i-1
        aa(i,j) = aa(i-1,j) - gamma(i)*aa(i-1,i-j);
     end
  end
  aa = [ 1 aa(M,:) ], pause

% Sygnal filtrowany
  Nx=100; n=0:Nx-1; x=sin(2*pi*n/12+pi/4);

% Filtracja kratowa "tylko zera" (rys. 8.1b i 8.5a):
% H1(z)=A(z)=[ 1 -0.9 0.64 -0.576 ];
  y1 = filtrK_Z( x, gamma);
  plot(y1); title('Sygnal wyjsciowy - filtr: tylko zera'); pause

% Porownanie ze zwykla filtracja
  y1z = filter(a,1,x);
  plot(y1-y1z); title('Roznica z filter(a,1,x)');

%-----------------------------------------------------------------------------------
% function y = filtrK_Z(x,gamma)
% Filtr kratowy - tylko zera
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl
% N=length(x);
% M=length(gamma);
% eb(1:M) = zeros(1,M);
% for n = 1 : N
%   ea(1) = x(n);     % kolejna probka
%   for k = 1 : M     % kolejne sekcje filtra (8.2)
%      ea(k+1) = ea(k) - gamma(k)*eb(k);
%      ebnext(k+1) = eb(k) - gamma(k)*ea(k);
%   end
%   eb = [ x(n) ebnext(2:M) ];
%   y(n) = ea(k+1);
% end
