% Przyklad 8.2
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl
  
  clear all; clf;
  
% Podaj wspolczynniki transmitancji H(z)=1/A(z) filtra (UWAGA! a(1)=1, M<=N)
  a = [ 1 -0.9 0.64 -0.576 ];

% Podaj wspolczynniki transmitancji H(z)=A(z) filtra (UWAGA! a(1)=1, M<=N)
  a = [ 1 -0.9 0.64 -0.576 ];
  N = length(a);
  aa = a(2:N); M=N-1; % odrzucamy pierwszy element rowny 1
  
% Oblicz wspolczynniki "odbicia" gamma(i) filtra kratowego - tabela 8.1,
% rownania (8.21)(8.22)
  aij(M,1:M)=aa(1:M);
  for i=M:-1:1
      gamma(i)=-aij(i,i);
      for j=1:i-1
          aij(i-1,j) = (aij(i,j)+gamma(i)*aij(i,i-j))/(1-gamma(i)^2);
      end
  end
  gamma, pause
  
% Sygnal filtrowany
  Nx=100; n=0:Nx-1; x=sin(2*pi*n/12+pi/4);

% Filtracja kratowa "tylko bieguny" (rys. 8.2b i 8.5b):
% H2(z)=1/A(z)=1/[ 1 -0.9 0.64 -0.576 ];
  y2 = filtrK_B( x, gamma);
  plot(y2); title('Sygnal wyjsciowy - filtr: tylko bieguny'); pause

% Porownanie ze zwykla filtracja
  y2z = filter(1,a,x);
  subplot(111); plot(y2-y2z); title('Roznica z filter(1,a,x)');

%-----------------------------------------------------------------------------------
% function y = filtrK_B(x,gamma)
% Filtr kratowy - tylko bieguny
% N=length(x);
% M=length(gamma);
% eb(1:M) = zeros(1,M);
% for n = 1 : N
%   ea(M+1) = x(n);      % kolejna probka
%   for k = M : -1 : 1   % kolejne sekcje filtra (8.27)
%      ea(k) = ea(k+1) + gamma(k)*eb(k);
%      eb(k+1) = eb(k) - gamma(k)*ea(k);
%   end
%   eb = [ ea(1) eb(2:M+1) ];
%   y(n) = ea(1);
% end