function ym = edet(x, alpha, lambda)

N = 256;   % dlugosc ramki
K = 128;   % nakladanie sie ramek
adpt = 40; % czas adaptacji (liczba ramek)
x = x(:);
m = 0;

for n = 1:N-K:length(x)-N,
    m = m + 1;

    xw = x(n:n+N-1);                % obliczanie energii w m-tej ramce
    ex(m) = xw'*xw;

    if m > adpt & ex(m) > thr(m-1), % wypowiedz
        ym(m) = 1;
        thr(m) = thr(m-1);
    else                            % przerwa w wypowiedzi
        ym(m) = 0;
        if m == 1, ed = ex(m); ed2 = ed^2; end;
        ed  = alpha*ed  + (1-alpha)*ex(m);           % est. wartosci oczek.
        ed2 = alpha*ed2 + (1-alpha)*ex(m)^2;         % est. wariancji
        thr(m) = ed + lambda*sqrt(abs(ed2 - ed2^2)); % prog decyzyjny
    end;
end;


