function parameters = MCRA_estimation(Pxx, parameters)

alpha = 0.95;
beta = 0.1;
delta = 2.5;
L = 50;

% oszacowania z poprzedniej ramki
pkl = parameters.pkl;   % szacunkowe prawdopodob. wypowiedzi
l = parameters.l;       % indeks ramki
Pmin = parameters.Pmin; % estymata minimum statystyki
Ptmp = parameters.Ptmp; % wektor pomocniczy

if rem(l,L)==0
    Pmin = min(Ptmp,Pxx);
    Ptmp = Pxx;
else
    Pmin = min(Pmin,Pxx); Ptmp = min(Ptmp,Pxx);
end

Srk = Pxx./Pmin;
Ikl = zeros(length(Srk),1);
Ikl(find(Srk > delta)) = 1;
pkl = beta*pkl + (1-beta) * Ikl;       % prawdopodob. wypowiedzi
alpha_t = alpha + (1-alpha)*pkl;       % parametr usredniajacy
Pdd = alpha_t.*Pdd + (1-alpha_t).*Pxx; % estymacja PSD szumu

% zapis parametrow dla ramki l+1
parameters.pkl = pkl; 
parameters.l = l+1;
parameters.Pdd = Pdd;
parameters.Pmin = Pmin;
parameters.Ptmp = Ptmp;