%Przyklad 19.4
%Wywolae biblioteki TracesPlay i odczytanie trzech wartosci dla kazdego
%pakietu, czas w sekundach i mikrosekundach oraz rozmiar pakietu IP
pcapPola = TracesPlay('-o HEADER.timeS HEADER.timeUs IP.len -r test.pcap');
czas = double(pcapPola(1,:))-double(pcapPola(1,1)); %Normalizacja czasu
czas = czas + double(pcapPola(2,:))*10^-6; %Dodanie czynnika mikrosekund
tmp = cumsum(double(pcapPola(3,:))); %Obliczanie szybkosci bitowej
tmp =(tmp(10:10:end)-[0 tmp(10:10:end-9)])./(czas(10:10:end)-[0 czas(10:10:end-9)]);
plot(czas(10:10:end), tmp) %Generowanie wykresu z opisem osi
xlabel('Czas przybycia ostatniego z 10 pakietow');
ylabel('Szybkosc bitowa kolejnych 10 pakietow');