% Przyklad 21.08
function w = mnoz_wiel_bin(p,q)
% Funkcja mnozy wielomiany zadane zmiennymi p i q i zwraca w(x)
% Wspolczynniki wielomianow ss reprezentowane od najwyzszej potegi:
% x^3 + x + 1 = [1 0 1 1]
% Spolszczona wersja programu dostarczonego wraz z ksiazka
% T.K. Moona "Error Correction Coding"

m = 2;	% GF(2) - wspolczynniki binarne
if(all(p==0) | all(q==0))
    w = 0;
else
    w = mod(conv(p,q),m);
end