% Przyklad 23.5
function [ w ] = EigMinISI( c, Ld, Lw, D )
% c - odpowiedz impulsowa kanalu
% Ld - dlugosc prefiksu
% Lw - dlugosc korektora TEQ
% D - opoznienie skroconej odpowiedzi impulsowej
% w - obliczona odpowiedz impulsowa filtra TEQ
Lc = length( c );
Lz = Lc+Lw-1-Ld-D;
C = zeros( Lw, Lc+Lw-1 );
for i = 1:Lw
    C( i, i:i+Lc-1 ) = c;
end
Wd = zeros( Lc+Lw-1, Lc+Lw-1 ); Wr = Wd;
b = [ zeros( 1, D ), ones( 1, Ld ), zeros( 1, Lz ) ];
Wd = diag ( b ); Wr = diag ( 1-b );
Xd = C*Wd*C';
G = chol ( Xd );
Xr = C*Wr*C';
T = inv( G )'*Xr*inv( G );
[ V, D ] = eig( T );
LambdaMin = min( diag( D ) );
LambdaMinIdx = find( diag( D ) == LambdaMin );
w = V( :, LambdaMinIdx )'*inv( G )';
