% Przyklad 5.7
  clear all; close all;

% Inicjowanie wartosci parametrow
  N = 256;                        % liczba probek sygnalu
  M = 32;                         % liczba prazkow widma
  fpr = 128;                      % czestotliwosc probkowania
  fd = 10; fg = 20;               % czestotliwosci dolna i gorna
  df=(fg-fd)/(M-1); f=fd:df:fg;   % interesujace nas czestotliwosci
  x = rand(1, N);                 % sygnal analizowany, szum z przedzialu [0, 1]
  NM1 = N+M-1;
  A = exp( -j*2*pi * fd/fpr );                                   % punkt startowy
  W = exp( -j*2*pi * ((fg-fd)/(2*(M-1))/fpr) );                  % krok
  y1 = zeros(1,NM1); k=0:N-1; y1(k+1)= ((A*W.^k).^k) .* x(k+1);  % inicjowanie y1
  k = [ 0 : M-1, -(N-1):1:-1]; y2 = W.^(-k.^2);                  % inicjowanie y2
  %k = [ 0:-1:-(N-1), M-1:-1:1]; k = [ k(1) fliplr(k(2:end))]; y2 = W.^(-k.^2);

% inicjowanie y2
  Y1 = fft(y1);       % # algorytm szybkiego splotu kolowego
  Y2 = fft(y2);       % # sygnalow y1 i y2
  Y = Y1.*Y2;         % #
  y = ifft(Y)/(N/2);  % #
  k=0:M-1; XcztN(k+1) = y(k+1) .* (W.^(k.^2)); % korekcja fazowa wyniku splotu
  n = 0:N-1; Xref=x*exp(-j*2*pi*n(:)*f/fpr);   % obliczenia na podstawie definicji DTFT (2.14)
  Xref = Xref/(N/2);                           % skalowanie
  blad = max(abs( XcztN - Xref )),             % blad w stosunku do obliczen z definicji
  subplot(2,1,1);
         plot(f,real(XcztN),'r.-'); grid on; hold on;
         plot(f,real(Xref),'bo-');
  subplot(2,1,2);
         plot(f,imag(XcztN),'r.-'); grid on; hold on;
         plot(f,imag(Xref),'bo-'); pause