% Przyklad 6.1
function przyklad_06_01()

M = 8;                                             % Liczba kanalow zespolu filtrow.
h = dctIImtx(M);      % Macierz wspolczynnikow filtrow analizy (wiersz odpowiada ...
% filtrowi). Np. filtry okreslone macierza DCT.
f = fliplr(h);       % Wspolczynniki filtrow syntezy. W przypadku DCT uzyskiwane ...
% z odwrocenia kolejnosci wspolczynnikow filtrow analizy.
S = M;                     % Wspolczynnik podprobkowania. Np. probkowanie krytyczne.

x = [1 zeros(1, 32 - 1)];                % Sygnal wejsciowy. Np. impuls jednostkowy.
xs = fb_analysis(h, S, x);	                          % Analiza sygnalu wejsciowego.
% Sygnaly kanalow w wierszach $xs$.
ys = xs; % Brak przetwarzania kanalow, aby sprawdzic czy zespol filtrow zapewnia PR.
y = fb_synthesis(f, S, ys);    % Synteza wyjsciowego sygnalu sygnalu pelnopasmowego.

fb_show_io(x, y, 512);       % Obrazowanie sygnalu oryginalnego i zrekonstruowanego.
fb_show_response(h, 256);           % Obrazowanie charakterystyk filtrow.