% Przyklad 14.1
% Podzial sygnalu na ramki

[x,fpr,nbit]=wavread('AF1K1_3_.WAV');   % wczytanie sygnalu dzwiekowego do wektora x

twind = 30;                 % dlugosc okna obserwacji (ramki danych) w 
                            % milisekundach
tstep = 15;                 % przesuniecie pomiedzy kolejnymi 
                            % polozeniami okna w milisekundach
n = (twind*0.001)*fpr;      % liczba probek okna (ramki danych)
m = (tstep*0.001)*fpr;      % liczba probek przesuniecia pomiedzy 
                            % kolejnymi polozeniami okna

ramkowanie(x,hamming(n),m); % wywolanie funkcji dzielacej sygnal w wektorze x na ramki.
                            % wywolanie funkcji bez argumentu wyjsciowego
                            % powoduje wyswietlenie pierwszych dziesieciu
                            % ramek