% Przyklad 14.3
% Obliczanie wspolczynnikow MFCC i ich wizualizacja

[s,fs,nbit]=wavread('AF1K1_3_.WAV'); % wczytanie pliku WAV
        % s - wektor z sygnalem
        % fs - czestotliwosc probkowania

w='0';  % Jezeli w='0', to zostal uwzgledniony zerowy wspolczynnik MFCC
nc=12;  % liczba wspolczynnikow MFCC z wylaczeniem zerowego wspolczynnika
p=30;   % liczba filtrow w banku filtrow
n=480;  % dlugosc ramki w probkach
inc=160;    % przesuniecie miedzy poczatkami ramek w probkach
fl=0;   % dolny kraniec pierwszego filtra z banku filtrow wyrazony jako 
        % ulamek fs 
fh=0.5; % gorny kraniec ostatniego filtra z banu filtrow wyrazony jako 
        % ulamek fs
        
melcepstrum(s,fs,w,nc,p,n,inc,fl,fh); % obliczanie wspolczynnikow MFCC. 
                                      % Wywolanie funkcji melcepstrum bez 
                                      % argumentow wyjsciowych powoduje 
                                      % wizualizacje macierzy 
                                      % wspolczynnikow MFCC reprezentujacej 
                                      % przetwarzane slowo. Dla wiekszej 
                                      % przejrzystosci programu nie 
                                      % uwzgledniono w nim procedur do 
                                      % obliczania pierwszej i drugiej 
                                      % pochodnej.