function [classes, paths, num_files, num_classes] = load_list(filename)
    [classes, paths] = textread(filename, '%d %s');
    if ( size(classes) ~= size(paths) ) 
        error(strcat('Liczba klas rozna od liczby sciezek w pliku ', filename));
    end
    num_files = size(paths,1);
    num_classes = size(unique(classes, 'rows'), 1);
end
