%   Przyklad 16.3
n = length (dane);                                          %obliczenie liczby probek
pow_of_2= 2^ (ceil( log2( n)));                             %obliczenie liczby probek potrzebnych do ...
                                                            %... przeprowadzenia operacji filtrowania
rozdzielczosc= Fs/ pow_of_2;                                %  obliczenie jaka, dla takiej liczby probek... 
                                                            %...bedzie rozdzielczosc czestotliwosciowa
    
x= zeros( 1, pow_of_2);                                     %uzupelnienie probek zerami na koncu...
x( 1: n)= dane;                                             %...do obliczonej wczesniej dlugosci
dane_fft = fft( x, pow_of_2);                               % przejscie na dziedzine czestotliwosciowa
    
faktorDb( 1: pow_of_2/2+ 1)= interp1( filtr( :, 1), ...     %zwiekszenie rozdzielczosci zdefiniowanego..
    filtr( :, 2), (0: pow_of_2/2)* rozdzielczosc);          %...filtra do obliczonej 'rozdzielczosc'
faktor= 10.^ (faktorDb/ 20);                                %zmiana skali filtra na liniowa
faktor= [faktor, fliplr( faktor( 2: pow_of_2/2))];          %doklejenie lustrzanego odbicia filtra
    
dane_fft = dane_fft.* faktor;                               % przemnozenie spektrum sygnalu przez filtr
dane = ifft(dane_fft, pow_of_2);                            % powrot do dziedziny czasowej
dane_y = dane_y ( 1: n);                                    %skrocenie przefiltrowanego sygnalu do
                                                            % pierwotnej dlugosci
