%Przyklad 19.6
%Uwzglednienie kompresji
bitRate=TracesPlay('-o HEADER.timeS HEADER.timeUs IP.len -r animacjaSRC16.yuv_200.pcap_0.pcap');
czas = double(bitRate(1,:))-double(bitRate(1,1));
czas = czas + double(bitRate(2,:))*10^-6;
len = double(bitRate(3,:));
czasMax = floor(czas(end)); %Ustalenie pelnych sekund jakie sa w sladzie ruchu
bitRateEst = zeros(1,czasMax);
for j=1:czasMax,
bitRateEst(j) = sum(8*len(czas>j-1 & czas <j)); %Suma dlugosci pakietow ...
%w zakresie j-1 do j
end
k = mean(bitRateEst)/1000000; %Przeliczenie wyniku na megabity na sekunde
QoE=5-4*exp(-2.055*k); %Wzor 19.9
fprintf('Sekwencja animacjaSRC16.yuv_200.pcap_0.pcap ma srednia przeplywnosc %.1f kbit/s, oszacowany poziom QoE wynosi %.3f\n', k*1000, QoE);