% Przyklad 21.05
function [X,dmin] = gen_kod_lin(G)
% Funkcja generuje slowa kodu liniowego o zadanej macierzy generujacej  zadanej jako zmienna G
% Podaje rowniez odleglosc minimalna dla tego kodu oraz znajduje slowa kodowe
% Np. G = [1 0 0 1; 0 1 0 1; 0 0 1 1] dla kodu (3,4) z kontrola parzystosci

[k,n] = size(G);
if(k>n)
    disp('Bledna macierz generujaca! k>n');
else
    dmin=n;
    X = [];
    for i=0:2^k-1
        u=dec2bin(i,k)-'0';
        x=mod(u*G,2);
        X = [X; x];
        fprintf('u = [%s] odpowiada x = [%s]\n', num2str(u), num2str(x));
        d=mean(x)*n;
        if(i>0 & dmin>d)
            dmin=d;
        end
    end
end