function IQ = numer2IQ( symbole )
% generowanie zespolnonych symboli DQPSK
% wejscie: liczby 0(00), 1(01), 2(10), 3(11) odpowadajace skokom fazy +pi/4, +3pi/4, -pi/4, -3pi/4

skoki_fazy = [1 3 -1 -3];        % wielkrotnosci pi/4
skok = skoki_fazy( symbole+1 );  % numery symboli --> skoki fazy
mnoznik = [0];
for i = 1:length(symbole)
    mnoznik = [ mnoznik mod( mnoznik(end)+skok(i), 8) ];
end
IQ = exp( j*pi/4*mnoznik );

end