%% Przyklad 22.1 -- Koder modulatora dla M-PSK oraz 16 QAM
A=2; % Amplituda
M=4; % wartosciowowsc modulacji M-PSK
n=1:M;
I = A*cos((2*n)*pi/M); % wartosc skladowej synfazowej
Q = A*sin((2*n)*pi/M); % wartosc skladowej kwadraturowej
fi=0:0.01:2*pi; %
tytul = strcat(num2str(M), '-PSK'); figure(1);
plot(I,Q,'ro',A*cos(fi),A*sin(fi),'b-'); xlabel('I'); ylabel('Q');
title(tytul); grid on;

%% Koder modulatora dla 16QAM (w tablicy)
Iqam(1) = 0.4472; Qqam(1) =0.4472; Iqam(2) = 0.4472; Qqam(2) =1.3416;
Iqam(3) = 1.3416; Qqam(3) =0.4472; Iqam(4) = 1.3416; Qqam(4) =1.3416;
Iqam(5) = 0.4472; Qqam(5) =-0.4472; Iqam(6) = 0.4472; Qqam(6) =-1.3416;
Iqam(7) = 1.3416; Qqam(7) =-0.4472; Iqam(8) = 1.3416; Qqam(8) =-1.3416;
Iqam(9) = -0.4472; Qqam(9) =0.4472; Iqam(10) = -0.4472; Qqam(10) =1.3416;
Iqam(11) = -1.3416; Qqam(11) =0.4472; Iqam(12) = -1.3416; Qqam(12) =1.3416;
Iqam(13) = -0.4472; Qqam(13) =-0.4472; Iqam(14) = -0.4472; Qqam(14) =-1.3416;
Iqam(15) = -1.3416; Qqam(15) =-0.4472; Iqam(16) = -1.3416; Qqam(16) =-1.3416;

Aqam = unique(abs(Iqam + 1i*Qqam)); % wartosci amplitud
figure(2); plot2 = plot(Iqam,Qqam,'ro');
xlabel('I'); ylabel('Q'); title(tytul); grid on; title ('16QAM');
hold on
for k=1:length(Aqam)
    plot(Aqam(k)*cos(fi),Aqam(k)*sin(fi),'b-')
end
hold off